#!/bin/bash -
# update-initramfs.sh.  Generated from update-initramfs.sh.in by configure.
# Copyright (C) 2009 Red Hat Inc.
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

# Update the daemon inside an existing initramfs.  Avoids the
# timeconsuming rebuild.

set -e

output=initramfs.fedora-10.x86_64.img

# Make a safe 'install_file' function to install files into the
# filesystem.  XXX We need a 'febootstrap-install' utility.
# Usage: install_file <local-file> <target-pathname> mode owner[.group]
install_file ()
{
    cp "$1" initramfs/"$2"
    # Get the inode of the new file and remove it from fakeroot.log.
    ino=$(ls -i initramfs/"$2" | awk '{print $1}')
    cp initramfs/fakeroot.log fakeroot.log.old
    grep -v "ino=$ino," fakeroot.log.old > initramfs/fakeroot.log
    rm fakeroot.log.old
    # Set mode, owner and group as desired.
    febootstrap-run initramfs -- chmod "$3" "$2"
    febootstrap-run initramfs -- chown "$4" "$2"
}

# Copy the daemon into the filesystem.
install_file /home/rjones/d/libguestfs/daemon/guestfsd /sbin/guestfsd 0755 root.root

# Generate final image.
febootstrap-to-initramfs initramfs > $output-t
mv $output-t $output
ls -lh $output
